Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Jobs/FileOpeningService.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Jobs/FileOpeningService.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/Jobs/FileOpeningService.cs	(revision 13739)
@@ -16,4 +16,7 @@
     public class FileOpeningService
     {
+        public Guid UserId { get; set; }
+
+        private WebLoginService weblog;
         public RefreshableJob Job { get; set; }
         public FileOpeningViewModel vm { get; set; }
@@ -22,16 +25,13 @@
             get; set; }
         public List<int> previousLogs { get; set; }
-        private static FileOpeningService instance;
-        public static FileOpeningService Instance
+        
+
+        public FileOpeningService(Guid u)
         {
-            get
-            {
-                if (instance == null)
-                {
-                    instance = new FileOpeningService();
-                }
-                return instance;
-            }
+            weblog = WebLoginService.Instance;
+            UserId = u;
         }
+
+
         /// <summary>
         /// Clears loaded jobs and start new one
@@ -58,5 +58,5 @@
         {
            // HiveClientWeb.Instance.Refresh();
-            HiveClientWeb.LoadJob(Job);
+            weblog.getClientWeb(UserId).LoadJob(Job);
         }
         /// <summary>
@@ -68,14 +68,8 @@
             if (vm != null)
             {
-
-
-
-                HiveServiceLocatorWeb serv = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
-                //job.Job.Id = serv.getHiveServiceClient().AddJob(job.Job);
-                //  job.Job =  serv.getHiveServiceClient().GetJob(job.Job.Id);
-
-                HiveClientWeb.CurrentEnv = env;
-                HiveClientWeb.Instance.Refresh();
-                HiveClientWeb.StartJob((ex) => { throw ex; }, Job, CancellationToken.None);
+                var clientWeb = weblog.getClientWeb(UserId);
+                clientWeb.CurrentEnv = env;
+                clientWeb.Refresh();
+                clientWeb.StartJob((ex) => { throw ex; }, Job, CancellationToken.None);
                 return Job;
             }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/WebLoginService.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/WebLoginService.cs	(revision 13739)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Services/WebLoginService.cs	(revision 13739)
@@ -0,0 +1,127 @@
+﻿using HeuristicLab.Clients.Hive.WebJobManager.ViewModels;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Clients.Hive.WebJobManager.Services
+{
+    /// <summary>
+    /// A service that will handle all the logins and will serve as a singleton that controls
+    /// all the necessary Services used by Hive. (HiveServiceLocatorWeb and HiveClientWeb instances per user). 
+    /// Users are identified with a seperate Guid made by the web version to ensure login security.
+    /// </summary>
+    public class WebLoginService
+    {
+        private static WebLoginService instance;
+        private List<LoginViewModel> loggedIn;
+        private List<HiveServiceLocatorWeb> locators;
+        private List<HiveClientWeb> webclients;
+        private List<FileOpeningService> fileopeners;
+        /// <summary>
+        /// Service instance that keeps all the information per user seperated. 
+        /// </summary>
+        public static WebLoginService Instance
+        {
+            get
+            {
+                if (instance == null)
+                {
+                    instance = new WebLoginService();
+                }
+                return instance;
+            }
+        }
+        /// <summary>
+        /// Initialize all lists
+        /// </summary>
+        public WebLoginService()
+        {
+
+            loggedIn = new List<LoginViewModel>();
+            locators = new List<HiveServiceLocatorWeb>();
+            webclients = new List<HiveClientWeb>();
+            fileopeners = new List<FileOpeningService>();
+        }
+        /// <summary>
+        /// Creates a new entry for a user. Services will be kept running here untill the user logs out or times out. 
+        /// </summary>
+        /// <param name="log">LoginViewModel from new user</param>
+        /// <param name="loc">HiveServiceLocatorWeb created during login</param>
+        public void newLogin(LoginViewModel log, HiveServiceLocatorWeb loc)
+        {
+            destroyPossiblePreviousSessions(log.loginName);
+            var ind = loggedIn.Find(x => x.loginName == log.loginName);
+            if (ind != null)
+            {
+                logout(ind.userId);
+            }
+            loggedIn.Add(log);
+            locators.Add(loc);
+            var temp = new HiveClientWeb(loc, log.userId);
+            webclients.Add(temp);
+            var temp2 = new FileOpeningService(log.userId);
+            fileopeners.Add(temp2);
+        }
+
+        private void destroyPossiblePreviousSessions(string client)
+        {
+            var ind = loggedIn.FindAll(x => x.loginName == client);
+            foreach (var i in ind)
+            {
+                locators.RemoveAll(x => x.UserId == i.userId);
+                webclients.RemoveAll(x => x.UserId == i.userId);
+                fileopeners.RemoveAll(x => x.UserId == i.userId);
+                loggedIn.RemoveAll(x => x.userId == i.userId);
+            }
+
+        }
+        /// <summary>
+        /// Returns the service locator for a user
+        /// </summary>
+        /// <param name="id">User id</param>
+        /// <returns></returns>
+        public HiveServiceLocatorWeb getServiceLocator(Guid id)
+        {
+            return locators.Find(x => x.UserId == id);
+        }
+        /// <summary>
+        /// Returns HiveClientWeb for a user
+        /// </summary>
+        /// <param name="id">User id</param>
+        /// <returns></returns>
+        public HiveClientWeb getClientWeb(Guid id)
+        {
+            return webclients.Find(x => x.UserId == id);
+        }
+        /// <summary>
+        /// Returns the LoginViewModel for a user
+        /// </summary>
+        /// <param name="id">User id</param>
+        /// <returns></returns>
+        public LoginViewModel getLoginViewModel(Guid id)
+        {
+            return loggedIn.Find(x => x.userId == id);
+        }
+        /// <summary>
+        /// Returns the FileOpenerService for the user
+        /// </summary>
+        /// <param name="id">User id</param>
+        /// <returns></returns>
+        public FileOpeningService getFileOpener(Guid id)
+        {
+            return fileopeners.Find(x => x.UserId == id);
+        }
+        /// <summary>
+        /// Removes all traces from the logged in user
+        /// </summary>
+        /// <param name="id">User id</param>
+        public void logout(Guid id)
+        {
+            loggedIn.RemoveAll(x => x.userId == id);
+            webclients.RemoveAll(x => x.UserId == id);
+            locators.RemoveAll(x => x.UserId == id);
+            fileopeners.RemoveAll(x => x.UserId == id);
+        }
+    }
+}
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Startup.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Startup.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Startup.cs	(revision 13739)
@@ -7,5 +7,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.PluginInfrastructure;
-
+using System;
 
 namespace HeuristicLab.Clients.Hive.WebJobManager
@@ -33,5 +33,10 @@
 
             services.AddMvc();
-            services.AddSingleton<ILoginViewModelService, LoginViewModelService>();
+
+            services.AddCaching();
+            services.AddSession(options => {
+                options.IdleTimeout = TimeSpan.FromMinutes(30);
+                options.CookieName = ".HiveWJM";
+            });
             services.AddSingleton<IHiveServiceLocator, HiveServiceLocatorWeb>();
             services.AddSignalR();
@@ -45,5 +50,5 @@
 
             app.UseIISPlatformHandler();
-            
+            app.UseSession();
             app.UseStaticFiles();
             app.UseSignalR();
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/LoginViewModel.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/LoginViewModel.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/ViewModels/LoginViewModel.cs	(revision 13739)
@@ -12,10 +12,37 @@
     public class LoginViewModel
     {
+        /// <summary>
+        /// Used only for the WebHive. Identifies logged in users.
+        /// </summary>
+        public Guid userId { get; set; }
+        /// <summary>
+        /// Login name from the user 
+        /// </summary>
         [Display(Name = "Username")]
         public string loginName { get; set; }
+        /// <summary>
+        /// Encrypted password
+        /// </summary>
         [Display(Name = "Password")]
         public string password { get; set; }
 
         public string errorMessage { get; set; }
+        /// <summary>
+        /// Initialize the loginViewModel. Creates a unique Guid for the WebHive 
+        /// </summary>
+        /// <param name="n">Login name</param>
+        /// <param name="p">Encrypted password</param>
+        public LoginViewModel(string n, string p)
+        {
+            loginName = n;
+            password = p;
+            userId = Guid.NewGuid();
+        }
+        public LoginViewModel()
+        {
+            userId = Guid.Empty;
+            loginName = "";
+            password = "";
+        }
     }
 }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Index.cshtml	(revision 13739)
@@ -1,5 +1,5 @@
 ﻿@using HeuristicLab.Clients.Hive.WebJobManager.ViewModels
 @model JobViewModel
-
+<div id="userId" style="display:none">@ViewBag.SessionId</div>
 <div>
     @Html.Partial("Navbar", new NavbarViewModel("Job"))
@@ -165,4 +165,5 @@
                     }
                 </div>
+                
 
         }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFile.cshtml	(revision 13739)
@@ -1,3 +1,5 @@
-﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.FileOpeningViewModel
+﻿@using Microsoft.AspNet.Http;
+
+@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.FileOpeningViewModel
 
 
@@ -9,5 +11,5 @@
       onscroll="showScrolly()"
       style="margin-bottom:500px;margin-left:1px;margin-right:1px;">
-
+    <div id="userId" style="display:none">@ViewBag.SessionId</div>
     @Html.Partial("Navbar", new HeuristicLab.Clients.Hive.WebJobManager.ViewModels.NavbarViewModel("Job"))
 
@@ -181,4 +183,5 @@
         </ul>
     </nav>
+    
     <script src="~/js/scripts/hubber.js"></script>
     <script>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/UploaderPartial/_UploaderPartial.cshtml	(revision 13739)
@@ -25,8 +25,13 @@
         <div class="row" style="margin:10px">
 
-            <div id="selectedfiles"></div>
+            <div id="selectedfiles">
+            <h3>Files</h3>
+            <p>No files selected: press the above button to choose files</p>
+            </div>
 
-            <div style="display:none; margin-bottom:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+            <button style="margin-bottom:10px; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;"
+                 type="button"
+                    disabled
                  id="del"
                  class='btn btn-danger'
@@ -34,8 +39,8 @@
                 <span class='glyphicon glyphicon-trash' aria-hidden='true'></span>
                 Remove files
-            </div>
+            </button>
 
-            <div id="dir"
-                 style="display:none; margin-top:20px;margin-bottom:20px">
+            <div 
+                 style="margin-top:20px;margin-bottom:20px">
 
                 <label for="basic-url">Directory name</label>
@@ -45,5 +50,7 @@
                         .../uploads/@ViewBag.Name
                     </span>
-                    <input type="text"
+                    <input 
+                           type="text"
+                           disabled
                            class="form-control"
                            id="directory"
@@ -53,7 +60,8 @@
                 </div>
             </div>
-            <button style="display:none; box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+            <button style=" box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
                             text-shadow:2px 2px black;"
-                   id="upl"
+                   disabled
+                    id="upl"
                    class="btn btn-lg btn-block btn-success"
                    type="submit"
@@ -70,11 +78,11 @@
         var div = document.getElementById("selectedfiles");
         var files = document.getElementById("files").files;
-        div.innerHTML = "";
+        div.innerHTML = "<h3>Files</h3>";
         if (files.length > 0) {
-            document.getElementById("upl").style.display = "";
-            document.getElementById("del").style.display = "";
-            document.getElementById("dir").style.display = "";
+            document.getElementById("upl").disabled = false;
+            document.getElementById("del").disabled = false;
+            document.getElementById("directory").disabled = false;
 
-            div.innerHTML += "<h3>Files</h3>";
+            
             for (var i = 0; i < files.length; i++) {
                 div.innerHTML += "<p>File " + (i + 1) + ":" + files[i].name +
@@ -84,7 +92,8 @@
         }
         else {
-            document.getElementById("upl").style.display = "none";
-            document.getElementById("del").style.display = "none";
-            document.getElementById("dir").style.display = "none";
+            div.innerHTML += "<p>No files selected</p>";
+            document.getElementById("upl").disabled = true;
+            document.getElementById("del").disabled = true;
+            document.getElementById("directory").disabled = true;
         }
 
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Uploads.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Uploads.cshtml	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/Uploads.cshtml	(revision 13739)
@@ -45,5 +45,10 @@
             <div class="col-sm-4">
                 <div class="btn-group-vertical btn-block">
-                    <a class="btn btn-success btn-lg btn-block
+                    <a class="btn btn-info btn-lg btn-block disabled"
+                       style="box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19);
+                            text-shadow:2px 2px black;">
+                        <i class="fa fa-cloud"></i> Uploads
+                    </a>
+                    <a class="btn btn-success btn-block
                        @(Model.SelectedIndex == -1 ? "active" : "")
                        "
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Shared/_Layout.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Shared/_Layout.cshtml	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Shared/_Layout.cshtml	(revision 13739)
@@ -12,4 +12,5 @@
     </environment>
     <link href="https://gitcdn.github.io/bootstrap-toggle/2.2.0/css/bootstrap-toggle.min.css" rel="stylesheet">
+    <link rel="shortcut icon" type="image/x-icon" href="~/favicon.ico" />
     <link rel="stylesheet" href="//rawgithub.com/Caged/d3-tip/master/examples/example-styles.css">
 </head>
@@ -28,10 +29,5 @@
         <script src="~/js/jquery.signalr-2.1.2.js"></script>
         <script src='~/signalr/js'></script>
-        <script src="~/js/morris.js"></script>
-        <script src="~/js/npm.js"></script>
-        <script src="~/js/raphael.js"></script>
         <script src="~/js/plotly.js"></script>
-        <script src="~/js/moment.js"></script>
-        <script src="~/js/moment-timezone-with-data.js"></script>
         <script src="~/js/d3.js"></script>
         <script src="~/js/d3.v3.min.js"></script>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphHubber.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphHubber.js	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/Graphs/GraphHubber.js	(revision 13739)
@@ -2,5 +2,8 @@
 
 $(function () {
-    //$.connection.hub.logging = true;
+  //  $.connection.hub.logging = true;
+    var v = document.getElementById("userId").innerHTML;
+    console.log(v);
+    $.connection.hub.qs = { 'userid': v };
     $.connection.hub.start().done(function () {
         hubber.server.initConnection();
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/hubber.js
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/hubber.js	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/wwwroot/js/Scripts/hubber.js	(revision 13739)
@@ -2,5 +2,8 @@
 
 $(function () {
-    $.connection.hub.logging = true;
+   // $.connection.hub.logging = true;
+    var v = document.getElementById("userId").innerHTML;
+    console.log(v);
+    $.connection.hub.qs = { 'userid': v };
     $.connection.hub.start().done(function () {
         $("#progress").css("width", 0 + '%');
